<?php
// $Id: browse_predicates.inc,v 1.3 2006/02/02 14:04:51 dman Exp $

/**
 * @file
 *  
 * Page to render all nodes with a set predicate,  like taxonomy can render
 * all nodes in their category
 * Based largely on taxonomy.module
 */

/*! @addtogroup browse Relationship navigator
 *  @{
 */



/**
 * Format a list of all subjects with a given relationship defined.
 * That is,  any item that even _has_ anything said about it 
 * using the given predicate,  no matter what the subjects are.
 * Inverse implications are supported too.
 * @param  string Valid predicate identifier
 * @return HTML fragment,  titles and teasers,  similar to that returned by taxonomy pages. 
 */
function theme_relationship_all_with_statement($predicate) {
  if (! $predicate || ! ($term = relationship_get_term($predicate) ) ) {
    drupal_set_message("Invalid predicate passed to all_with_statement() . '$predicate' is not a known term.", 'error');
    return;
  }
  
  $statements = print_r(relationship_query(NULL, $predicate) );


}




/**
 * from Taxonomy_render_nodes()
 * TODO? unused yet
 * Accepts the result of a pager_query() call,  such as that performed by
 * taxonomy_select_nodes(),  and formats each node along with a pager.
*/
function relationship_render_nodes($result) {
  if (db_num_rows($result) > 0) {
    while ($node = db_fetch_object($result) ) {
      $output .= node_view(node_load(array('nid' => $node->subject) ),  1);
    }
    $output .= theme('pager',  NULL,  variable_get('default_nodes_main',  10),  0);
  }
  else {
    $output .= t('There are currently no items with this relationship defined.');
  }
  return $output;
}

/**
 * Menu callback; displays all nodes associated with a term.
 */
function relationship_term_page($str_tids = '',  $depth = 0,  $op = 'page') {
  if (preg_match('/^([0-9]+[+ ])+[0-9]+$/',  $str_tids) ) {
    $operator = 'or';
    // The '+' character in a query string may be parsed as ' '.
    $tids = preg_split('/[+ ]/',  $str_tids);
  }
  else if (preg_match('/^([0-9]+, )*[0-9]+$/',  $str_tids) ) {
    $operator = 'and';
    $tids = explode(', ',  $str_tids);
  }
  else {
    drupal_not_found();
  }

  // Needed for '+' to show up in RSS discovery URLs
  $rss_tids = urlencode($str_tids);

  if ($tids) {
    // Build title:
    $all_terms = relationship_get_terms();
    
    $names = array();
    foreach ($tids as $term) {
      $names[] = $term->label;
    }

    if ($names) {
      drupal_set_title($title = implode(',  ',  $names) );

      switch ($op) {
        case 'page':

          drupal_add_link(array('rel' => 'alternate',
                                'type' => 'application/rss+xml',
                                'title' => 'RSS - '. $title,
                                'href' => url('rss_metadata/term/'. $rss_tids .'/'. $depth .'/feed') ) );

          $output = taxonomy_render_nodes(taxonomy_select_nodes($tids,  $operator,  $depth,  TRUE) );

          $output .= theme('xml_icon',  url("rss_metadata/term/$rss_tids/$depth/feed") );
          print theme('page',  $output);
          break;

        case 'feed': // TODO?
          $term = taxonomy_get_term($tids[0]);
          $channel['link'] = url('taxonomy/term/'. $str_tids .'/'. $depth,  NULL,  NULL,  TRUE);
          $channel['title'] = variable_get('site_name',  'drupal') .' - '. $title;
          $channel['description'] = $term->description;

          $result = taxonomy_select_nodes($tids,  $operator,  $depth,  FALSE);
          node_feed($result,  $channel);
          break;
        default:
          drupal_not_found();
      }
    }
    else {
      drupal_not_found();
    }
  }
}



/*! 
 *  @}
 */


?>
